#include <stddef.h>
#include <stdint.h>
//#include <printf.h>
// you need to sort all these into diffrent files! TODO
int strncmp(const char *s1, const char *s2, unsigned int n) {
  int i;
  for(i = 0; ((i <= n) && (s1[i] != '\0') && (s2[i] != '\0')); i++) {
    if(s1[i] != s2[i]) {
      return(s1[i] - s2[i]);
    }
  }
  return(s1[i] - s2[i]);
}

int strcmp(const char *s1, const char *s2) {
  int i;
  for(i = 0; ((s1[i] != '\0') && (s2[i] != '\0')); i++) {
    if(s1[i] != s2[i]) {
      return(s1[i] - s2[i]);
    }
  }
  return(s1[i] - s2[i]);
}

int memcmp(const void *s1, const void *s2, size_t n) {
  const unsigned char *p1 = s1; // Why is c such a bitch? 
  const unsigned char *p2 = s2;
  int i;
  for(i = 0; i < n; i++) {
    if(p1[i] != p2[i]) {
      return(p1[i] - p2[i]);
    }
  }
  return(p1[n-1] - p2[n-1]);
}

void strcpy(char *dest, char *src) {
  for(unsigned int i = 0; src[i] != '\0'; i++){
    dest[i] = src[i];
  }
}

void memcpy(char *dest, char *src, size_t n) {
  for(unsigned int i = 0; i <= n; i++) {
    dest[i] = src[i];
  }
}
